Codeforces Round #222 (Div. 1) B. Preparing for the Contest 二分+线段树

B. Preparing for the Contest

题目连接:

http://codeforces.com/contest/377/problem/B

Description

Soon there will be held the world’s largest programming contest, but the testing system still has m bugs. The contest organizer, a well-known university, has no choice but to attract university students to fix all the bugs. The university has n students able to perform such work. The students realize that they are the only hope of the organizers, so they don’t want to work for free: the i-th student wants to get ci ‘passes’ in his subjects (regardless of the volume of his work).

Bugs, like students, are not the same: every bug is characterized by complexity aj, and every student has the level of his abilities bi. Student i can fix a bug j only if the level of his abilities is not less than the complexity of the bug: bi ≥ aj, and he does it in one day. Otherwise, the bug will have to be fixed by another student. Of course, no student can work on a few bugs in one day. All bugs are not dependent on each other, so they can be corrected in any order, and different students can work simultaneously.

The university wants to fix all the bugs as quickly as possible, but giving the students the total of not more than s passes. Determine which students to use for that and come up with the schedule of work saying which student should fix which bug.

Input

The first line contains three space-separated integers: n, m and s (1 ≤ n, m ≤ 105, 0 ≤ s ≤ 109) — the number of students, the number of bugs in the system and the maximum number of passes the university is ready to give the students.

The next line contains m space-separated integers a1, a2, …, am (1 ≤ ai ≤ 109) — the bugs’ complexities.

The next line contains n space-separated integers b1, b2, …, bn (1 ≤ bi ≤ 109) — the levels of the students’ abilities.

The next line contains n space-separated integers c1, c2, …, cn (0 ≤ ci ≤ 109) — the numbers of the passes the students want to get for their help.

Output

If the university can’t correct all bugs print “NO”.

Otherwise, on the first line print “YES”, and on the next line print m space-separated integers: the i-th of these numbers should equal the number of the student who corrects the i-th bug in the optimal answer. The bugs should be corrected as quickly as possible (you must spend the minimum number of days), and the total given passes mustn’t exceed s. If there are multiple optimal answers, you can output any of them.

Sample Input

3 4 9
1 3 1 2
2 1 3
4 3 6

Sample Output

YES
2 3 2 3

Hint

题意

有一个学校,有m个bug,有n个大学生,每个大学生的能力值是b[i],bug的能力值是a[i],如果b[i]>=a[j],那么第i个人能够修复j bug

现在每个大学生你需要支付c[i]元,支付给他之后,他可以每天修复一个能力值小于等于他能力值的bug

你需要尽量少的天数,以及在花费小于s的情况下,修复这些bug

问你怎么去做?

题解:

如果能在T天修复完,那么显然也能够在T+1天内修复完,所以这个是具备二分性的

然后我们就二分答案,那么我们找到一个最便宜的人去修复[m,m-T+1]的bug,再找一个人去修复[m-T,m-2T+1],等等等

这样就好了

然后我们用一个线段树去维护这个玩意儿就好了

代码

#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e5 + 15;

struct Person{
    int cost , val , idx ;
    friend bool operator < (const Person & a , const Person & b){
        return a.val < b.val;
    }
}p[maxn];
int N , M , S , maxv , ans[maxn];

pair < int , int > a[maxn];

bool cmp( const pair < int , int > & x , const pair < int , int > & y){
    return x.first > y.first;
}


struct Sgtree{
    
    struct node{
        int l , r ;
        int pos , minv;
    }tree[maxn << 2];
    
    
    void Maintain( int o ){
        int lson = o << 1 , rson = o << 1 | 1;
        if( tree[lson].minv < tree[rson].minv ) tree[o].minv = tree[lson].minv , tree[o].pos = tree[lson].pos;
        else tree[o].minv = tree[rson].minv , tree[o].pos = tree[rson].pos;
    }
    
    void Build( int l , int r , int o ){
        tree[o].l = l , tree[o].r = r ;
        if( r > l ){
            int mid = l + r >> 1;
            Build( l , mid , o << 1 );
            Build( mid + 1 , r , o << 1 | 1 );
            Maintain( o );
        }else tree[o].pos = l , tree[o].minv = p[l].cost;
    }
    
    void Modify( int p , int o ){
        int l = tree[o].l , r = tree[o].r;
        if( l == r ) tree[o].minv = 2e9;
        else{
            int mid = l + r >> 1;
            if( p <= mid ) Modify( p , o << 1 );
            else Modify( p , o << 1 | 1 );
            Maintain( o );
        }
    }
    
    pair < int , int > ask( int ql , int o ){
        int l = tree[o].l , r = tree[o].r;
        if(ql <= l) return make_pair( tree[o].minv , tree[o].pos );
        else{
            int mid = l + r >> 1;
            pair < int , int > ls , rs ;
            ls.first = rs.first = 2e9;
            if( ql <= mid ) ls = ask( ql , o << 1 );
            rs = ask( ql , o << 1 | 1 );
            if( ls.first < rs.first ) return ls;
            return rs;
        }
    }
    
}Sgtree;

bool solve( int T ){
    Sgtree.Build(1 , N , 1);
    vector < int > vi;
    int j = N  , money = S;
    for(int i = 1 ; i <= M ; i += T){
        while( j >= 1 && p[j].val >= a[i].first ) -- j;
        pair < int , int > rp = Sgtree.ask( j + 1 , 1 );
        if( rp.first > money ) return false;
        money -= rp.first;
        Sgtree.Modify(rp.second , 1);
        vi.push_back( p[rp.second].idx );
    }
    int lst = 0 , ptr = 0;
    for(int i = 1 ; i <= M ; ++ i){
        ans[a[i].second] = vi[ptr];
        ++ lst;
        if( lst == T ) lst = 0 , ++ ptr;
    }
    return true;
}


int main( int argc , char * argv[] ){
    scanf("%d%d%d",&N,&M,&S);
    for(int i = 1 ; i <= M ; ++ i){
        scanf("%d" , &a[i].first);
        a[i].second = i;
        maxv = max( maxv , a[i].first );
    }
    int find = 0;
    for(int i = 1 ; i <= N ; ++ i) scanf("%d" , &p[i].val);
    for(int i = 1 ; i <= N ; ++ i){
        scanf("%d" , &p[i].cost);
        p[i].idx = i ;
        if( p[i].val >= maxv && p[i].cost <= S ) find = 1;
    }
    if( find == 0 ) printf("NO\n");
    else{
        sort( a + 1 , a + M + 1 , cmp );
        sort( p + 1 , p + N + 1 );
        int l = 1 , r = max(N,M);
        while( l < r ){
            int mid = l + r >> 1;
            if( solve( mid ) ) r = mid;
            else l = mid + 1;
        }
        solve( l );
        printf("YES\n");
        for(int i = 1 ; i <= M ; ++ i) printf("%d ", ans[i]);
        printf("\n");
    }
    return 0;
}
    原文作者:qscqesze
    原文地址: https://www.cnblogs.com/qscqesze/p/5541305.html
    本文转自网络文章,转载此文章仅为分享知识,如有侵权,请联系博主进行删除。
点赞